<template>
  <b-card class="animated fadeIn" title="Tạo mới nhân viên">
    <b-tabs>
      <b-tab title="Thông tin" active>
        <b-row>
          <b-col sm="6">
            <b-form-group>
              <label for="name">Tên nhân viên</label>
              <b-form-input type="text" id="name" name="name" v-model="user.name" data-vv-as="Tên nhân viên"
                v-validate="'required'" :class="{'is-invalid': errors.has('name')}"></b-form-input>
              <span v-show="errors.has('name')" class="form-text text-muted text-danger">{{
                errors.first('name') }}</span>
            </b-form-group>
            <b-form-group>
              <label for="email">Email</label>
              <b-form-input type="text" id="email" name="email" v-model="user.email" data-vv-as="Email" v-validate="'required|email'"
                :class="{'is-invalid': errors.has('email')}"></b-form-input>
              <span v-show="errors.has('email')" class="form-text text-muted text-danger">{{
                errors.first('email') }}</span>
            </b-form-group>
            <b-form-group>
              <label for="phone">SĐT</label>
              <b-form-input type="text" id="phone" name="phone" v-model="user.phone" data-vv-as="SĐT" v-validate="'required|min:9'"
                :class="{'is-invalid': errors.has('phone')}"></b-form-input>
              <span v-show="errors.has('phone')" class="form-text text-muted text-danger">{{
                errors.first('phone') }}</span>
            </b-form-group>
            <b-form-group>
              <label for="password">Mật khẩu</label>
              <b-form-input type="password" id="password" ref="password" name="password" v-model="user.password" data-vv-as="Mật khẩu" v-validate="'required|min:6'"
                :class="{'is-invalid': errors.has('password')}"></b-form-input>
              <span v-show="errors.has('password')" class="form-text text-muted text-danger">{{
                errors.first('password') }}</span>
            </b-form-group>
            <b-form-group>
              <label for="re_password">Nhập lại mật khẩu</label>
              <b-form-input type="password" id="re_password" name="re_password" v-model="re_password" data-vv-as="Nhập lại mật khẩu" v-validate="'confirmed:password'"
                :class="{'is-invalid': errors.has('re_password')}"></b-form-input>
              <span v-show="errors.has('re_password')" class="form-text text-muted text-danger">{{
                errors.first('re_password') }}</span>
            </b-form-group>
            <b-form-group>
              <label for="re_password">Quyền hạn</label>
                <b-form-select v-model="user.role_id" class="mb-3">
                    <option :value="null" selected>Chọn Quyền hạn</option>
                    <option v-for="role in roles" :key="role.id" :value="role.id">{{ role.description }}</option>
                </b-form-select>
            </b-form-group>
            <b-button variant="success" @click.stop="validateBeforeSubmit()">Save</b-button>
          </b-col>
        </b-row>
      </b-tab>
    </b-tabs>
  </b-card>
</template>
<script>
import { http } from "@/services";
import { alerts } from "@/utils";
export default {
  data() {
    return {
      user: {
        name: "",
        email: "",
        password: "",
        role_id: ""
      },
      re_password: "",
      roles: null
    };
  },
  created() {
    this.fetchRoles();
  },
  methods: {
    fetchRoles() {
      http.get("/role", response => {
        this.roles = response.data;
      });
    },
    async saveInfo() {
      return new Promise((resolve, reject) => {
        http.post(
          "/user/store",
          {
            user: this.user
          },
          response => {
            this.user = response.data.data;
            return resolve(response.data);
          }
        );
      });
    },
    redirect() {
      this.$router.push("/users");
    },
    validateBeforeSubmit() {
      this.$validator.validateAll().then(result => {
        if (result) {
          // eslint-disable-next-line
          alerts.ajaxConfirm(
            "Xác nhận tạo mới nhân viên?",
            "question",
            this.saveInfo,
            this.redirect
          );
          return;
        }

        // alert('Correct them errors!');
      });
    }
  },
  computed: {}
};
</script>

